<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if( !empty($setmodules) )
{
	$filename = basename(__FILE__);
	$module['系统']['风格'] = $filename;
	return;
}

define('IN_PHPBB', true);
define('ROOT_PATH', './../');
require('./pagestart.php');

$confirm = ( isset($_POST['confirm']) ) ? true : false;

if( isset($_GET['mode']) || isset($_POST['mode']) )
{
	$mode = ( isset($_GET['mode']) ) ? $_GET['mode'] : $_POST['mode'];
	$mode = htmlspecialchars($mode);
}
else 
{
	$mode = '';
}

switch( $mode )
{
	// 卸载风格
	case 'uninstall':
	
		// 指定卸载的风格路径
		$uninstall_to 	= ( isset($_GET['uninstall_to']) ) ? $_GET['uninstall_to'] : $_POST['uninstall_to'];

		//  没有选择风格
		if (!$uninstall_to)
		{
			message_die(GENERAL_MESSAGE, '没有选中任何风格！');
		}
		
		// 不卸载
		if ( isset($_POST['cancel']) )
		{
			redirect(append_sid('admin/admin_styles.php', true));
		}
		
		// 出于系统的稳定的保证，请不要删除默认的 prosilver 风格
		if ($uninstall_to == 'prosilver')
		{
			message_die(GENERAL_MESSAGE, '默认风格是不能卸载的！<br >点击 <a href="' . append_sid('admin_styles.php') . '">这里</a> 返回风格管理页面！<br />点击 <a href="' . append_sid('index.php?pane=right') . '">这里</a> 返回超级管理面板导航');
		}
		
		$sql = 'SELECT style_id 
			FROM ' . STYLES_TABLE . " 
			WHERE style_path = '" . $db->sql_escape($uninstall_to) . "'
			LIMIT 1";
			
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, '无法查询 ' . STYLES_TABLE . ' 表', '', __LINE__, __FILE__, $sql);
		}
		
		// 数据库中没有您要删除的风格
		if ( !$db->sql_numrows($result) )
		{
			message_die(GENERAL_MESSAGE, '您要删除的风格没有安装<br />点击 <a href="' . append_sid('admin_styles.php') . '">这里</a> 返回风格管理页面！<br />点击 <a href="' . append_sid('index.php?pane=right') . '">这里</a> 返回超级管理面板导航');
		}
		
		$uninstall_style_data = $db->sql_fetchrow($result);
		
		// 网站默认的风格删除了，匿名用户？？
		if($uninstall_style_data['style_id'] == $board_config['default_style'])
		{
			message_die(GENERAL_MESSAGE, '您不能卸载您设置的网站默认风格，如要删除请把默认风格设置为其它风格');
		}
		
		// 确认卸载
		if( !$confirm )
		{
			
			$hidden_fields = '<input type="hidden" name="mode" value="'.$mode.'" />
			<input type="hidden" name="uninstall_to" value="'.$uninstall_to.'" />';

			$template->set_filenames(array(
				'confirm' => 'admin/confirm_body.tpl')
			);

			$template->assign_vars(array(
				'MESSAGE_TITLE' 	=> '卸载',
				'MESSAGE_TEXT' 		=> '提示：卸载该风格的同时会删除该风格的首页排版，请问是否卸载此风格？',

				'L_YES' 			=> '是',
				'L_NO' 				=> '否',

				'S_CONFIRM_ACTION' 	=> append_sid('admin_styles.php'),
				'S_HIDDEN_FIELDS' 	=> $hidden_fields)
			);

			$template->pparse("confirm");

		}
		else
		{
			
			$sql = 'DELETE FROM ' . MODULES_TABLE . '
				WHERE module_style_id = ' . (int) $uninstall_style_data['style_id'];

			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '无法删除' . MODULES_TABLE . '表的数据', '', __LINE__, __FILE__, $sql);
			}

			// 删除已卸载风格的数据
			$sql = 'DELETE FROM ' . STYLES_TABLE . " 
				WHERE style_id = " . (int) $uninstall_style_data['style_id'];
				
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '无法删除' . STYLES_TABLE . '表的数据', '', __LINE__, __FILE__, $sql);
			}
			
			// 把使用此风格的用户风格设置为1
			$sql = 'UPDATE ' . USERS_TABLE . " 
				SET user_style = 1
				WHERE user_style = " . (int) $uninstall_style_data['style_id'];
				
			if( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, '无法删除' . USERS_TABLE . ' 表的数据', '', __LINE__, __FILE__, $sql);
			}
			
			$message = '风格已成功卸载 <br />点击 <a href="' . append_sid('admin_styles.php') . '">这里</a> 返回风格管理页面！<br />点击 <a href="' . append_sid('index.php?pane=right') . '">这里</a> 返回超级管理面板导航';

			message_die(GENERAL_MESSAGE, $message);
		}
		break;
		
	case 'install':
	
		// 获取要安装的风格
		$install_to = ( isset($_GET['install_to']) ) ? urldecode($_GET['install_to']) : $_POST['install_to'];

		// 取得安装风格的信息
		$stylecfg = parse_cfg_file(ROOT_PATH. 'styles/' . $install_to . '/install.cfg');
		
		if ( empty($stylecfg) )
		{
			message_die(GENERAL_MESSAGE, "$sub_dir 安装包不合法，请检查 $sub_dir 安装包的 install.cfg 是否正确");
		}
		
		if ( empty($install_to) )
		{
			message_die(GENERAL_MESSAGE, '请指定要安装的风格');
		}
		
		$sql = 'SELECT style_id 
			FROM ' . STYLES_TABLE . " 
			WHERE style_path = '" . $db->sql_escape($install_to) . "'
			LIMIT 1";
			
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, '无法查询 ' . STYLES_TABLE . ' 表', '', __LINE__, __FILE__, $sql);
		}
		
		if ( $db->sql_numrows($result) )
		{
			message_die(GENERAL_MESSAGE, '该风格已安装<br />点击 <a href="' . append_sid('admin_styles.php') . '">这里</a> 返回风格管理页面！<br />点击 <a href="' . append_sid('index.php?pane=right') . '">这里</a> 返回超级管理面板导航');
		}
		
		$sql = "INSERT INTO " . STYLES_TABLE . " (style_name, style_path, style_version, style_copyright) 
			VALUES ('" . $db->sql_escape($stylecfg['name']) . "', '" . $db->sql_escape($stylecfg['path']) . "', '" . $db->sql_escape($stylecfg['version']) . "', '" . $db->sql_escape($stylecfg['copyright']) . "')";
		
		if( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, '无法往' . STYLES_TABLE . ' 表插入数据', '', __LINE__, __FILE__, $sql);
		}
		
		$message = $stylecfg['name'] . ' 风格已成功安装！<br />点击 <a href="' . append_sid('admin_styles.php') . '">这里</a> 返回风格列表！<br />点击 <a href="' . append_sid('index.php?pane=right') . '">这里</a> 返回管理面板导航';
		message_die(GENERAL_MESSAGE, $message);
		break;
		
	default:
		// 列出已安装的风格
		$sql = 'SELECT *
			FROM ' . STYLES_TABLE . ' 
			ORDER BY style_id ASC';
		if(!$result = $db->sql_query($sql))
		{
			message_die(GENERAL_ERROR, '无法查询 ' . STYLES_TABLE . ' 表', '', __LINE__, __FILE__, $sql);
		}
		$style_row = $db->sql_fetchrowset($result);

		for($i = 0; $i < count($style_row); $i++)
		{
			$row_class = ( !($i % 2) ) ? 'row1' : 'row2';

			$template->assign_block_vars('styles', array(
				'ROW_CLASS' 		=> $row_class,
				'STYLE_NAME' 		=> $style_row[$i]['style_name'],
				'STYLE_ID' 			=> $i + 1,
				'STYLE_VERSION' 	=> $style_row[$i]['style_version'],
				'STYLE_COPYRIGHT' 	=> $style_row[$i]['style_copyright'],
				'U_STYLE_EDIT' 		=> append_sid('admin_styles.php?mode=edit&amp;style_id=' . $style_row[$i]['style_id']),
				'U_STYLE_UNINSTALL' => append_sid('admin_styles.php?mode=uninstall&amp;uninstall_to=' . $style_row[$i]['style_path']))
			);
		}
		
		// 列出未安装的风格
		$notinstall_styles = array();
		if( $dir = @opendir(ROOT_PATH . 'styles/') )
		{
			while( $sub_dir = @readdir($dir) )
			{
				if( !is_file(phpbb_realpath(ROOT_PATH . 'styles/' .$sub_dir)) && !is_link(phpbb_realpath(ROOT_PATH . 'styles/' . $sub_dir)) && $sub_dir != '.' && $sub_dir != '..' && $sub_dir != 'index.htm' )
				{
					if( @file_exists(@phpbb_realpath(ROOT_PATH. 'styles/' . $sub_dir . '/install.cfg')) )
					{

						$stylecfg = parse_cfg_file(ROOT_PATH. 'styles/' . $sub_dir . '/install.cfg');

						if ( empty($stylecfg) )
						{
							message_die(GENERAL_MESSAGE, "$sub_dir 安装包不合法，请检查 $sub_dir 安装包的 install.cfg 是否正确");
						}
						
						// 风格的文件夹
						$style_path = $stylecfg['path'];
						
						$sql = 'SELECT style_id 
							FROM ' . STYLES_TABLE . " 
							WHERE style_path = '" . str_replace("\'", "''", $style_path) . "'";
							
						if(!$result = $db->sql_query($sql))
						{
								message_die(GENERAL_ERROR, '无法查询 ' . STYLES_TABLE . ' 表', '', __LINE__, __FILE__, $sql);
						}
						// 未安装的风格
						if ( !$db->sql_numrows($result) )
						{
							$notinstall_styles[] = $stylecfg;
						}
						
					}
				}
			}
		}
		
		for($i = 0; $i < count($notinstall_styles); $i++)
		{
			$row_class 	= ( !($i % 2) ) ? 'row1' : 'row2';
			$number 	= $i+1;
			
			$template->assign_block_vars('notinstall_styles', array(
				'ROW_CLASS' 		=> $row_class,
				'NUMBER' 			=> $number,
				'STYLE_NAME' 		=> $notinstall_styles[$i]['name'],
				'STYLE_VERSION' 	=> $notinstall_styles[$i]['version'],
				'STYLE_COPYRIGHT' 	=> $notinstall_styles[$i]['copyright'],
				'U_STYLES_INSTALL' 	=> append_sid('admin_styles.php?mode=install&amp;style=' . urlencode($notinstall_styles[$i]['name']) . '&amp;install_to=' . urlencode($notinstall_styles[$i]['path'])))
			);
		}

		$template->set_filenames(array(
			'body' => 'admin/styles_list_body.tpl')
		);
		
		$template->pparse('body');

}
require('./page_footer_admin.php');
?>