<?php
/**
* @package phpBB-WAP
* @copyright (c) phpBB Group
* @Оптимизация под WAP: Гутник Игорь ( чел ).
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

if ( !defined('IN_PHPBB') )
{
	exit;
}

class module_bbcode
{
	var $bbcodes = array();
	var $text;
	
	function parser_module_bbcode($text)
	{
		$this->text 	= $text;
		
		$this->text 	= ' ' . $this->text;
	
		// 如果没有BBCode标记则直接返回文本内容，别浪费资源
		if ( !(strpos($this->text, '[') && strpos($this->text, ']')) )
		{
			$this->text = substr($this->text, 1);
			return $this->text;
		}
		
		$this->bbcodes();
		$this->bbcode_replace();
		
		return $this->text;
	}
	
	function bbcode_replace()
	{
		
		$this->text = preg_replace_callback($this->bbcodes['other']['total']['key'], $this->bbcodes['other']['total']['value'], $this->text);

		foreach ($this->bbcodes['str'] as $str_find_tag => $str_replace_tag )
		{
			$this->text = str_replace($str_find_tag, $str_replace_tag, $this->text);
		}
		
		$this->text = preg_replace_callback($this->bbcodes['other']['ucp_link']['key'], $this->bbcodes['other']['ucp_link']['value'], $this->text);
		$this->text = preg_replace_callback($this->bbcodes['other']['forum']['key'], $this->bbcodes['other']['forum']['value'], $this->text);
		$this->text = preg_replace_callback($this->bbcodes['other']['topic']['key'], $this->bbcodes['other']['topic']['value'], $this->text);
	
		foreach ($this->bbcodes['preg'] as $patterns => $replacements)
		{
			$this->text = preg_replace($patterns, $replacements, $this->text);
		}
		
		$this->text = preg_replace_callback($this->bbcodes['other']['html']['key'], $this->bbcodes['other']['html']['value'], $this->text);
	}
	
	function bbcodes()
	{
		global $userdata, $board_config;
	
		$this->bbcodes = array(
			// 直接替换
			'str' => array(
				// HTML
				// 当标签如果是下列标签时，[html][/html]会比[b]...这些标签偏慢
				'[b]'			=> '<strong>',
				'[/b]'			=> '</strong>',
				'[u]'			=> '<u>',
				'[/u]'			=> '</u>',
				'[i]'			=> '<i>',
				'[/i]'			=> '</i>',
				'[del]'			=> '<del>',
				'[/del]'		=> '</del>',
				'[br]'			=> '<br />',
				'[hr]'			=> '<hr />',
				'[n]'			=> '&nbsp;',
				
				// 时间
				'[当前时间]'	=> create_date('G:i', time(), $board_config['board_timezone']),
				'[年]'			=> create_date('Y', time(), $board_config['board_timezone']),
				'[月]'			=> create_date('n', time(), $board_config['board_timezone']),
				'[日]'			=> create_date('j', time(), $board_config['board_timezone']),
				'[时]'			=> create_date('G', time(), $board_config['board_timezone']),
				'[分]'			=> create_date('i', time(), $board_config['board_timezone']),
				'[秒]'			=> create_date('s', time(), $board_config['board_timezone']),
				'[星期]'		=> $this->bbcode_week(),
				'[问候语]'		=> $this->bbcode_hello(),
				
				// 用户相关
				'[用户名]'		=> $userdata['username'],
				'[用户ID]'		=> $userdata['user_id'],
				'[未读信息]'	=> $userdata['user_unread_privmsg'],
				'[新信息]'		=> $userdata['user_new_privmsg'],
				'[邮箱]'		=> $userdata['user_email'],
				'[金币]'		=> $userdata['user_points'],
				'[注册时间]'	=> create_date('Y-m-d H:i', time(), $board_config['board_timezone']),
				
				//链接
				'[论坛链接]'	=> append_sid(ROOT_PATH . 'forum.php'),
				'[在线状态链接]'=> append_sid(ROOT_PATH . 'viewonline.php'),
				'[搜索链接]'	=> append_sid(ROOT_PATH . 'search.php'),
				'[规则链接]'	=> append_sid(ROOT_PATH . 'rules.php'),
				'[MODS中心链接]'=> append_sid(ROOT_PATH . 'mods.php'),
				'[会员列表链接]'=> append_sid(ROOT_PATH . 'memberlist.php'),
				'[小组列表链接]'=> append_sid(ROOT_PATH . 'groupcp.php'),

				// 统计
			//	'[统计会员]'	=> get_db_stat('usercount'),
			//	'[统计主题]'	=> get_db_stat('topiccount'),
			//	'[统计帖子]'	=> get_db_stat('postcount'),
			//	'[统计附件]'	=> get_db_stat('attachcount')
			),
			// 匹配替换
			'preg' => array(
				// HTML
				'#\[div=([0-9a-z\-_]+)\](.*?)\[/div\]#is'				=> '<div class="$1">$2</div>',
				'#\[email\]((.*?))\[/email\]#s'							=> '<a href="mailto:$1">$1</a>',
				'#\[email=([^\[]+)\](.*?)\[/email\]#s'					=> '<a href="mailto:$1">$2</a>',
				'#\[flash=([0-9]+),([0-9]+)\](.*?)\[/flash\]#s'			=> '<object classid="clsid:D27CDB6E-AE6D-11CF-96B8-444553540000" codebase="http://active.macromedia.com/flash2/cabs/swflash.cab#version=5,0,0,0" width="$1" height="$2"><param name="movie" value="$3" /><param name="play" value="false" /><param name="loop" value="false" /><param name="quality" value="high" /><param name="allowScriptAccess" value="never" /><param name="allowNetworking" value="internal" /><embed src="$3" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" width="$1" height="$2" play="false" loop="false" quality="high" allowscriptaccess="never" allownetworking="internal"></embed></object>',
				'#\[贴图\](.*?)\[/贴图\]#is'							=> '<img src="$1" alt="." />',
				'#\[视频=([0-9]+),([0-9]+)\](.*?)\[/视频\]#is'			=> '<video src="$3"  width="$1" height="$2" controls="controls">你的浏览器似乎不支持HTML5视频播放，赶紧换一个吧！</video>',
				'#\[声音\](.*?)\[/声音\]#s'								=> '<audio src="$1" controls="controls">你的浏览器似乎不支持HTML5音频播放，赶紧换一个吧！</audio>',
				'#\[超链接\](.*?)\[/超链接\]#s'							=> '<a href="$1">$1</a>',
				
				'#\[文字大小=([\-\+]?\d+)\](.*?)\[/文字大小\]#s'		=> '<span style="font-size: $1px; line-height: normal">$2</span>',
				'!\[文字颜色=(#[0-9a-f]{3}|#[0-9a-f]{6}|[a-z\-]+)\](.*?)\[/文字颜色\]!is'	=> '<span style="color: $1">$2</span>',
				'#\[拨打=(1[3|4|5|8][0-9]\d{8})](.*?)\[/拨打\]#s'		=> '<a href="wtai://wp/mc;$1">$2</a>',
				'#\[拨打\](1[3|4|5|8][0-9]\d{8})\[/拨打\]#s'			=> '<a href="wtai://wp/mc;$1">$1</a>',
				'#\[发短信=sms:(1[3|4|5|8][0-9]\d{8})\?body=(.*?)\](.*?)\[/发短信\]#is'	=> '<a href="sms:$1?body=$2">$3</a>',
				
				// 链接
				'#\[MOD=([0-9a-z\-_]{1,15})\]#is'						=> append_sid(ROOT_PATH . 'loading.php?mod=$1'),
				'#\[超链接=([^\[]+?)\](.*?)\[/超链接\]#s'				=> '<a href="$1">$2</a>',
				
			),
			// 其它不确定格式
			'other' => array(
				'ucp_link' => array(
					'key' 	=> '#\[我的地盘_(-1|[1-9][0-9]{0,7})\]#',
					'value'	=>  'module_bbcode::bbcode_ucp_link',
				),
				'forum' => array(
					'key'	=> '#\[调用论坛_([1-9][0-9]{0,7}(\,[1-9][0-9]{0,7})*?)_([0|1])_([0|1])_([1|2])\]#',
					'value'	=> 'module_bbcode::bbcode_use_forum',
				),
				'topic' => array(
					'key'	=> '#\[调用帖子_(0|[1-9][0-9]{0,7}(\,[1-9][0-9]{0,7})*?)_([0|1])_([1|2|3|4])_([1-7])_([1-9]|[1-2]\d|5[0])\]#',
					'value'	=> 'module_bbcode::bbcode_use_topic'
				),
				// 统计
				'total' => array(
					'key' 	=> '#\[统计_(1|2|3|4)\]#',
					'value' => 'module_bbcode::total_site'
				),
				// HTML
				'html'	=> array(
					'key'	=> '#\[html\](.*?)\[/html\]#s',
					'value'	=> 'module_bbcode::bbcode_html'
				)
			)
		);
	}
	
	/*
	* 统计网站信息
	* 1、统计用户
	* 2、统计主题
	* 3、统计帖子
	* 4、统计附件
	*/
	static function total_site($type)
	{
		switch ($type[1])
		{
			case 1:
				return get_db_stat('usercount');
				break;
			case 2:
				return get_db_stat('topiccount');
				break;
			case 3:
				return get_db_stat('postcount');
				break;
			case 4:
				return get_db_stat('attachcount');
				break;
			default:
				return $type[0];
		}
	}

	/*
	* HTML输出
	*/
	static function bbcode_html($html)
	{
		return htmlspecialchars_decode($html[1], ENT_QUOTES);
	}
	
	/* 
	* 格式[调用论坛_论坛或论坛分类ID_显示论坛分类或论坛_是否换行_显示模式]
	* 论坛的ID用,分隔
	* 显示论坛分类或论坛
	* 	0为论坛
	*	1为分类
	* 是否换行
	* 	0、否
	*	1、是
	* 显示模式：
	* 	1、为显示论坛的名称
	*	2、显示论坛的超链接
	*/
	static function bbcode_use_forum($forum)
	{
		global $db;
		
		if ($forum[3])
		{
			$sql = 'SELECT forum_id, forum_name 
				FROM ' . FORUMS_TABLE . '
				WHERE forum_id IN (' . $forum[1] . ')';
		}
		else
		{
			$sql = 'SELECT cat_id, cat_title 
				FROM ' . CATEGORIES_TABLE . '
				WHERE cat_id IN (' . $forum[1] . ')';
		}
		
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, '无法查询 forums 表的信息', '', __LINE__, __FILE__, $sql);
		}
		
		$module_text = '';
		$while_br = ($forum[4]) ? '<br />' : '';
		
		switch ($forum[5])
		{
			case 1:
				while( $row = $db->sql_fetchrow($result) )
				{
					$module_text .= ($forum[3]) ? $row['forum_name'] . $while_br : $row['cat_title'] . $while_br;
				}
			break;
			case 2:
				while( $row = $db->sql_fetchrow($result) )
				{
					$forum_or_cat_id = ($forum[3]) ? $row['forum_id'] : $row['cat_id'];
					$forum_or_cat_name = ($forum[3]) ? $row['forum_name'] : $row['cat_title'];
					$module_text .= ($forum[3]) ? 
						'<a href="' . append_sid(ROOT_PATH . 'viewforum.php?f=' . $forum_or_cat_id) . '">' . $forum_or_cat_name . '</a>' . $while_br : 
						'<a href="' . append_sid(ROOT_PATH . 'index.php?c=' . $forum_or_cat_id) . '">' . $forum_or_cat_name . '</a>' . $while_br;
				}
			break;
			
			default:
				return $forum[0];
		}
		
		return $module_text;
	}
	
	/* 
	* 格式[调用帖子_论坛ID_是否换行_显示模式_指定类型]
	* 论坛的ID用,分隔
	* 是否换行
	* 	0、否
	*	1、是
	* 显示模式：
	* 	1、显示帖子的名称
	*	2、显示帖子的超链接
	*	3、显示带标题号的帖子名称
	*	4、显示带标题号的帖子超链接
	* 指定类型
	* 	1、最新帖子
	*	2、热门帖子
	*	3、随机帖子
	* 	4、回复数
	*	5、动态帖子
	*	6、精华帖子
	*	7、专题帖子
	* 返回条数
	* 	最多50条
	*/
	static function bbcode_use_topic($topic)
	{
		global $db;
		
		$module_text = '';
		$while_br = ($topic[3]) ? '<br />' : '';
		$forum_sql = ($topic[1] == 0) ? '' : ' WHERE forum_id IN(' . $topic[1] . ') ';
		
		switch ($topic[5])
		{
			// 新帖
			case 1:
				$sql = 'SELECT topic_id, topic_title
					FROM ' . TOPICS_TABLE . '
					' . $forum_sql . '
					ORDER BY topic_id DESC
					LIMIT 0, ' . $topic[6];
				break;
			
			// 显示最近一个星期的热门帖子
			case 2:
				$sql = 'SELECT topic_id, topic_title 
					FROM ' . TOPICS_TABLE . '
					WHERE topic_time >= ' . (time() - 604800) . '
						' . $forum_sql . '
					ORDER BY topic_views 
					LIMIT 0, ' . $topic[6];
				break;
			
			// 随机数据
			case 3:
				$sql = 'SELECT topic_id, topic_title 
					FROM ' . TOPICS_TABLE . '
					' . $forum_sql . '
					WHERE topic_id >= (SELECT ROUND(RAND() * (SELECT MAX(topic_id) FROM ' . TOPICS_TABLE . ')))
					LIMIT 0, ' . $topic[6];
				break;
			
			// 按回复数量
			case 4:
				$sql = 'SELECT topic_id, topic_title 
					FROM ' . TOPICS_TABLE . '
					' . $forum_sql . '
					ORDER BY topic_replies DESC
					LIMIT 0 , ' . $topic[6];
				break;
			
			// 动态
			case 5:
				$forum_sql = ($topic[1] == 0) ? '' : ' AND t.forum_id IN(' . $topic[1] . ') ';
				
				$sql = 'SELECT t.topic_id, t.topic_title
					FROM ' . TOPICS_TABLE . ' AS t, ' . POSTS_TABLE . ' AS p
					WHERE p.post_id = t.topic_last_post_id
						' . $forum_sql . '
					ORDER BY p.post_id DESC 
					LIMIT 0, ' . $topic[6];
				break;

			// 精华帖子
			case 6:
				$sql = 'SELECT topic_id, topic_title
					FROM ' . TOPICS_TABLE . ' 
					WHERE topic_marrow = ' . POST_MARROW . '
					' . $forum_sql . '
					ORDER BY topic_id DESC
					LIMIT 0, ' . $topic[6];
				break;

			// 专题帖子
			case 7:
				$sql = 'SELECT topic_id, topic_title
					FROM ' . TOPICS_TABLE . '
					' . $forum_sql . '
						AND topic_class <> ' . TOPIC_UNCLASS . '
					ORDER BY topic_id DESC
					LIMIT 0, ' . $topic[6];
					break;
			
			default:
				return $topic[0];
		}
		
		if ( !($result = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, '无法查询 topics 表的信息', '', __LINE__, __FILE__, $sql);
		}
		
		switch ($topic[4])
		{
			// 只显示标题
			case 1:
				while( $row = $db->sql_fetchrow($result) )
				{
					$module_text .= $row['topic_title'] . $while_br;
				}
				break;
			
			// 显示超链接
			case 2:
				while( $row = $db->sql_fetchrow($result) )
				{
					$module_text .= '<a href="' . append_sid(ROOT_PATH . 'viewtopic.php?t=' . $row['topic_id']) . '">' . $row['topic_title'] . '</a>' . $while_br;
				}
				break;
			
			// 显示带标题号的帖子名称
			case 3:
				$i = 1;
				while( $row = $db->sql_fetchrow($result) )
				{
					$module_text .= $i . '、' . $row['topic_title'] . $while_br;
					$i++;
				}
				break;

			// 显示带标题号的帖子超链接
			case 4:
				$i = 1;
				while( $row = $db->sql_fetchrow($result) )
				{
					$module_text .= $i . '、<a href="' . append_sid(ROOT_PATH . 'viewtopic.php?t=' . $row['topic_id']) . '">' . $row['topic_title'] . '</a>' . $while_br;
					$i++;
				}
				break;
			// 虽然这是不会匹配到的...
			default:
				return $topic[0];
		}
		
		return $module_text;
	}
	
	/*
	* 创建个人中心的超链接
	* @参数 $user_id 指定用户的ID
	*/
	static function bbcode_ucp_link($user_id)
	{
		global $userdata;
		
		// 当指定的是游客ID时个人中心显示的是首页
		if ($user_id[1] == -1)
		{
			return append_sid(ROOT_PATH . 'index.php');
		}
		// 设置为0时则显示当前浏览的用户的ID
		else if ($user_id[1] == 0)
		{
			return append_sid(ROOT_PATH . 'ucp.php?mode=viewprofile&amp;' . POST_USERS_URL . '=' . $userdata['user_id']);
		}
		// 否则则链接指定的用户ID
		else
		{
			return append_sid(ROOT_PATH . 'ucp.php?mode=viewprofile&amp;' . POST_USERS_URL . '=' . $user_id[1]);
		}
	}
	
	/*
	* 获取今天是星期几
	*/
	function bbcode_week()
	{
		global $board_config;

		$week_data = create_date('N', time(), $board_config['board_timezone']);

		switch ($week_data)
		{
			case 1:
				$week_text = '一';
				break;
			case 2:
				$week_text = '二';
				break;
			case 3:
				$week_text = '三';
				break;
			case 4:
				$week_text = '四';
				break;
			case 5:
				$week_text = '五';
				break;
			case 6:
				$week_text = '六';
				break;
			case 7:
				$week_text = '日';
				break;
			
			default: 
				$week_text = '';
		}
		
		return $week_text;
	}
	
	function bbcode_hello()
	{
		global $board_config;

		$hello_time = create_date('H', time(), $board_config['board_timezone']);
		
		if ( $hello_time < 6)
		{
			$hello_text = '凌晨';
		}
		elseif ( $hello_time < 9)
		{
			$hello_text = '早上';
		}
		elseif ( $hello_time < 14)
		{
			$hello_text = '中午';
		}
		elseif ( $hello_time < 18)
		{
			$hello_text = '下午';
		}
		else
		{
			$hello_text = '晚上';
		}
		
		return $hello_text;
	}
}

?>