<?php
/**
* @package phpBB-WAP
* @简体中文：中文phpBB-WAP团队
* @license http://opensource.org/licenses/gpl-license.php
**/

/**
* 这是一款自由软件, 您可以在 Free Software Foundation 发布的
* GNU General Public License 的条款下重新发布或修改; 您可以
* 选择目前 version 2 这个版本（亦可以选择任何更新的版本，由
* 你喜欢）作为新的牌照.
**/

define('IN_PHPBB', true);
define('ROOT_PATH', './');
require ROOT_PATH . 'common.php';

$userdata = session_pagestart($user_ip, PAGE_MODS);
init_userprefs($userdata);

$per = 5;
$start = get_pagination_start($per);

$page_title = 'MODS中心';

require(ROOT_PATH . 'includes/page_header.php');

$sql = "SELECT SQL_CALC_FOUND_ROWS mod_name, mod_desc, mod_dir
	FROM " . MODS_TABLE . "
	WHERE mod_power = 1 
		AND mod_show = 1 
	LIMIT $start , $per";

if ( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, '查询 mods 表失败！', '', __LINE__, __FILE__, $sql);
}
$total_mod = $db->sql_numrows($result);

$mod_row = array();
while ($row = $db->sql_fetchrow($result))
{
	$mod_row[] = $row;
}

if ( !$total_mod )
{
	$template->assign_block_vars('empty_mods', array());
}

for ($i = 0; $i < $total_mod; $i++)
{
	$row_class = ( !($i % 2) ) ? 'row1' : 'row2';
	$template->assign_block_vars('mods_row', array(
		'ROW_CLASS'			=> $row_class,
		'MOD_NAME'			=> $mod_row[$i]['mod_name'],
		'MOD_DESC'			=> $mod_row[$i]['mod_desc'],
		'U_LOADING'			=> append_sid('loading.php?mod=' . $mod_row[$i]['mod_dir'] . '&load=' . $mod_row[$i]['mod_dir']))
	);
}


$sql = "SELECT found_rows() AS rowcount"; 

if ( !$result = $db->sql_query($sql) )
{
	message_die(GENERAL_ERROR, '查询 mods 表失败！', '', __LINE__, __FILE__, $sql);
}

if ( !$total_mods = $db->sql_fetchrow($result) )
{
	message_die(GENERAL_MESSAGE, '该 MOD 没有安装，如需要使用此 MOD 请联系管理员！');
}
$total_all_mods = $total_mods['rowcount'];

$pagination = generate_pagination("mods.php?", $total_all_mods, $per, $start);

$template->set_filenames(array(
	'body' => 'mods/mods_body.tpl')
);

$template->assign_vars(array(
	'PAGINATION' 	=> $pagination)
);

$template->pparse('body');

require(ROOT_PATH . 'includes/page_tail.php');
?>